## sddm 0.19.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.8)

project(SDDM)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

# Silence CMake 3.0 warnings
if(POLICY CMP0043)
    cmake_policy(SET CMP0043 OLD)
endif()

# Set version
set(SDDM_VERSION_MAJOR 0)
set(SDDM_VERSION_MINOR 19)
set(SDDM_VERSION_PATCH 0)
set(SDDM_VERSION_STRING "${SDDM_VERSION_MAJOR}.${SDDM_VERSION_MINOR}.${SDDM_VERSION_PATCH}")

# Set up packaging
set(CPACK_PACKAGE_NAME "sddm")
set(CPACK_PACKAGE_VERSION "${SDDM_VERSION_STRING}")
set(CPACK_GENERATOR "TGZ")
set(CPACK_SET_DESTDIR FALSE)
set(CPACK_SOURCE_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION}")
set(CPACK_SOURCE_IGNORE_FILES "/build/;/.git;/*.user;/.tx/;~$;${CPACK_SOURCE_IGNORE_FILES}")
include(CPack)
add_custom_target(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)

# Options
option(BUILD_MAN_PAGES "Build man pages" OFF)
option(ENABLE_JOURNALD "Enable logging to journald" ON)
option(ENABLE_PAM "Enable PAM support" ON)
option(NO_SYSTEMD "Disable systemd support" OFF)
option(USE_ELOGIND "Use elogind instead of logind" OFF)

# ECM
find_package(ECM 1.4.0 REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake;${CMAKE_MODULE_PATH};${ECM_MODULE_PATH}")

# Definitions
add_definitions(-Wall -std=c++11 -DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_FROM_BYTEARRAY -DQT_NO_FOREACH)

# Default build type
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release)
endif()

# Handle build type
if(CMAKE_BUILD_TYPE MATCHES [Dd]ebug)
    message(STATUS "Debug build")
    add_definitions(-DDEBUG)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -O0")
else()
    message(STATUS "Release build")
    add_definitions(-DNDEBUG)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O2")
endif()

# Default absolute paths
if(NOT DEFINED CMAKE_INSTALL_SYSCONFDIR)
    set(CMAKE_INSTALL_SYSCONFDIR "/etc")
endif()
if(NOT DEFINED CMAKE_INSTALL_LOCALSTATEDIR)
    set(CMAKE_INSTALL_LOCALSTATEDIR "/var")
endif()

# Standard installation paths
include(GNUInstallDirs)

# Macros
include(FeatureSummary)

# PKG-CONFIG
find_package(PkgConfig)

# PAM
if(ENABLE_PAM)
    find_package(PAM REQUIRED)

    if(PAM_FOUND)
        add_definitions(-DUSE_PAM)
    endif()
endif()
add_feature_info("PAM" PAM_FOUND "PAM support")

# getspnam and shadow(5) support
include(CheckFunctionExists)
check_function_exists(getspnam HAVE_GETSPNAM)

# XCB
find_package(XCB REQUIRED)

# XKB
find_package(XKB REQUIRED)

# Qt 5
find_package(Qt5 5.8.0 CONFIG REQUIRED Core DBus Gui Qml Quick LinguistTools Test)

# find qt5 imports dir
get_target_property(QMAKE_EXECUTABLE Qt5::qmake LOCATION)
if(NOT QT_IMPORTS_DIR)
    exec_program(${QMAKE_EXECUTABLE} ARGS "-query QT_INSTALL_QML" RETURN_VALUE return_code OUTPUT_VARIABLE QT_IMPORTS_DIR)
endif()

# Uninstall target
if ("${ECM_VERSION}" VERSION_LESS "1.7.0")
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
                   "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
                   IMMEDIATE @ONLY)
    add_custom_target(uninstall COMMAND ${CMAKE_COMMAND} -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")
endif()

# systemd
if(NOT NO_SYSTEMD AND NOT USE_ELOGIND)
    pkg_check_modules(SYSTEMD "systemd")
endif()

if(SYSTEMD_FOUND)
    add_definitions(-DHAVE_SYSTEMD)
    set(CMAKE_AUTOMOC_MOC_OPTIONS -DHAVE_SYSTEMD)

    # libsystemd-journal was merged into libsystemd in 209
    if(${SYSTEMD_VERSION} VERSION_LESS 209)
        pkg_check_modules(JOURNALD "libsystemd-journal")
    else()
        pkg_check_modules(JOURNALD "libsystemd")
    endif()

    if(ENABLE_JOURNALD)
        if(JOURNALD_FOUND)
            add_definitions(-DHAVE_JOURNALD)
            set(CMAKE_AUTOMOC_MOC_OPTIONS -DHAVE_JOURNALD)
        else()
            message(WARNING "Disable journald support for lack of libsystemd-journal")
        endif()
    endif()

    if (NOT DEFINED SYSTEMD_SYSTEM_UNIT_DIR)
        execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} --variable=systemdsystemunitdir systemd OUTPUT_VARIABLE SYSTEMD_SYSTEM_UNIT_DIR)
        string(REGEX REPLACE "[ \t\n]+" "" SYSTEMD_SYSTEM_UNIT_DIR ${SYSTEMD_SYSTEM_UNIT_DIR})
    endif()

    set(MINIMUM_VT 1)
    set(HALT_COMMAND "/usr/bin/systemctl poweroff")
    set(REBOOT_COMMAND "/usr/bin/systemctl reboot")
else()
    set(SYSTEMD_FOUND 0)
endif()
add_feature_info("systemd" SYSTEMD_FOUND "systemd support")
add_feature_info("journald" JOURNALD_FOUND "journald support")

# elogind
if(NO_SYSTEMD AND USE_ELOGIND)
    pkg_check_modules(ELOGIND "libelogind")
endif()

if(ELOGIND_FOUND)
    add_definitions(-DHAVE_ELOGIND)
    set(CMAKE_AUTOMOC_MOC_OPTIONS -DHAVE_ELOGIND)

    set(MINIMUM_VT 7)
    set(HALT_COMMAND "/usr/bin/loginctl poweroff")
    set(REBOOT_COMMAND "/usr/bin/loginctl reboot")
endif()
add_feature_info("elogind" ELOGIND_FOUND "elogind support")

# Default behaviour if neither systemd nor elogind is used
if (NOT ELOGIND_FOUND AND NOT SYSTEMD_FOUND)
    # Set the VT on which sddm will normally appear, and the
    # commands for shutdown and reboot. On FreeBSD, there are
    # normally more getty's running than on Linux.
    if("${CMAKE_SYSTEM_NAME}" STREQUAL "FreeBSD")
        set(MINIMUM_VT 9)
        set(HALT_COMMAND "/sbin/shutdown -p now")
    else()
        set(MINIMUM_VT 7)
        set(HALT_COMMAND "/sbin/shutdown -h -P now")
    endif()
    set(REBOOT_COMMAND "/sbin/shutdown -r now")
endif()


# Set constants
set(DATA_INSTALL_DIR            "${CMAKE_INSTALL_FULL_DATADIR}/sddm"                CACHE PATH      "System application data install directory")
set(DBUS_CONFIG_DIR             "${CMAKE_INSTALL_SYSCONFDIR}/dbus-1/system.d"       CACHE PATH      "DBus config files directory")
set(STATE_DIR                   "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/lib/sddm"      CACHE PATH      "State directory")
set(RUNTIME_DIR                 "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/run/sddm"      CACHE PATH      "Runtime data storage directory")
set(QML_INSTALL_DIR             "${QT_IMPORTS_DIR}"                                 CACHE PATH      "QML component installation directory")

set(SESSION_COMMAND             "${DATA_INSTALL_DIR}/scripts/Xsession"              CACHE PATH      "Script to execute when starting the X11 desktop session")
set(WAYLAND_SESSION_COMMAND     "${DATA_INSTALL_DIR}/scripts/wayland-session"       CACHE PATH      "Script to execute when starting the Wayland desktop session")

set(CONFIG_FILE                 "${CMAKE_INSTALL_FULL_SYSCONFDIR}/sddm.conf"        CACHE PATH      "Path of the sddm config file")
set(CONFIG_DIR                  "${CMAKE_INSTALL_FULL_SYSCONFDIR}/sddm.conf.d"      CACHE PATH      "Path of the sddm config directory")
set(SYSTEM_CONFIG_DIR           "${CMAKE_INSTALL_PREFIX}/lib/sddm/sddm.conf.d"      CACHE PATH      "Path of the system sddm config directory")
set(LOG_FILE                    "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/log/sddm.log"  CACHE PATH      "Path of the sddm log file")
set(DBUS_CONFIG_FILENAME        "org.freedesktop.DisplayManager.conf"               CACHE STRING    "Name of the sddm config file")
set(COMPONENTS_TRANSLATION_DIR  "${DATA_INSTALL_DIR}/translations"                  CACHE PATH      "Components translations directory")


# Autodetect UID_MIN and UID_MAX from /etc/login.defs
if(NOT DEFINED LOGIN_DEFS_PATH)
    set(LOGIN_DEFS_PATH "/etc/login.defs" CACHE PATH "Path to login.defs")
endif()

if(NOT EXISTS "${LOGIN_DEFS_PATH}" AND NOT DEFINED UID_MIN AND NOT DEFINED UID_MAX)
    message(FATAL_ERROR "Could not find login.defs at ${LOGIN_DEFS_PATH}. Try -DLOGIN_DEFS_PATH.")
endif()

if(NOT DEFINED UID_MIN)
    file(STRINGS "${LOGIN_DEFS_PATH}" UID_MIN LIMIT_COUNT 1 REGEX "^UID_MIN")
    string(REGEX REPLACE "^UID_MIN[\t ]+([0-9]+)" "\\1" UID_MIN "${UID_MIN}")
    if(NOT UID_MIN MATCHES "[0-9]+")
        message(WARNING "Could not detect a valid UID_MIN (got '${UID_MIN}'). You should review your login.defs file.")
        set(UID_MIN 1000)
    else()
        message(STATUS "Autodetected UID_MIN=${UID_MIN} from ${LOGIN_DEFS_PATH}")
    endif()
endif()

if(NOT DEFINED UID_MAX)
    file(STRINGS "${LOGIN_DEFS_PATH}" UID_MAX LIMIT_COUNT 1 REGEX "^UID_MAX")
    string(REGEX REPLACE "^UID_MAX[\t ]+([0-9]+)" "\\1" UID_MAX "${UID_MAX}")
    if(NOT UID_MAX MATCHES "[0-9]+")
        message(WARNING "Could not detect a valid UID_MAX (got '${UID_MAX}'). You should review your login.defs file.")
        set(UID_MAX 65000)
    else()
        message(STATUS "Autodetected UID_MAX=${UID_MAX} from ${LOGIN_DEFS_PATH}")
    endif()
endif()

# Add subdirectories
add_subdirectory(components)
add_subdirectory(data)
add_subdirectory(services)
add_subdirectory(src)

enable_testing()
add_subdirectory(test)

# Display feature summary
feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== components/CMakeLists.txt ===
configure_file("2.0/LayoutBox.qml" "2.0/LayoutBox.qml")

install(DIRECTORY "2.0/" DESTINATION "${QML_INSTALL_DIR}/SddmComponents")
install(DIRECTORY "common/" DESTINATION "${QML_INSTALL_DIR}/SddmComponents")
install(DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/2.0/" DESTINATION "${QML_INSTALL_DIR}/SddmComponents")

=== services/CMakeLists.txt ===
if(SYSTEMD_FOUND)
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/sddm.service.in" "${CMAKE_CURRENT_BINARY_DIR}/sddm.service")
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/sddm.service" DESTINATION "${SYSTEMD_SYSTEM_UNIT_DIR}")
endif()

if(USE_ELOGIND)
    set(LOGIND_PAM_MODULE "pam_elogind.so")
else()
    set(LOGIND_PAM_MODULE "pam_systemd.so")
endif()
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/sddm-greeter.pam.in" "${CMAKE_CURRENT_BINARY_DIR}/sddm-greeter.pam")

install(FILES sddm.pam DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/pam.d RENAME sddm)
install(FILES sddm-autologin.pam DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/pam.d RENAME sddm-autologin)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/sddm-greeter.pam" DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/pam.d RENAME sddm-greeter)

=== test/CMakeLists.txt ===
set(QT_USE_QTTEST TRUE)

include_directories(../src/common)

set(ConfigurationTest_SRCS ConfigurationTest.cpp ../src/common/ConfigReader.cpp)
add_executable(ConfigurationTest ${ConfigurationTest_SRCS})
add_test(NAME Configuration COMMAND ConfigurationTest)

target_link_libraries(ConfigurationTest Qt5::Core Qt5::Test)

=== data/themes/CMakeLists.txt ===
set(THEMES elarun maldives maya)

foreach(THEME ${THEMES})
    # We assume that theme-specific translations are stored
    # in ${THEME}/translations directory
    set(TRANSLATIONS_DIR "${THEME}/translations")
    file(GLOB TRANSLATION_SOURCES "${TRANSLATIONS_DIR}/*.ts")

    set_source_files_properties(${TRANSLATION_SOURCES} PROPERTIES OUTPUT_LOCATION "${CMAKE_CURRENT_BINARY_DIR}/${TRANSLATIONS_DIR}")

    qt5_add_translation(QM_FILES "${TRANSLATION_SOURCES}")

    install(DIRECTORY "${THEME}" DESTINATION "${DATA_INSTALL_DIR}/themes" PATTERN "${THEME}/*.ts"
            EXCLUDE PATTERN "${THEME}/.gitattributes"
            EXCLUDE)

    list(APPEND THEMES_QM_FILES ${QM_FILES})
endforeach(THEME)

add_custom_target(themes-translation DEPENDS ${THEMES_QM_FILES})

=== data/translations/CMakeLists.txt ===
set(TRANSLATION_FILES
    ar.ts
    bn.ts
    ca.ts
    cs.ts
    da.ts
    de.ts
    es.ts
    et.ts
    eu.ts
    fi.ts
    fr.ts
    hi_IN.ts
    he.ts
    hu.ts
    ie.ts
    is.ts
    it.ts
    ja.ts
    kk.ts
    ko.ts
    lt.ts
    lv.ts
    nb.ts
    nl.ts
    nn.ts
    oc.ts
    pl.ts
    pt_BR.ts
    pt_PT.ts
    ro.ts
    ru.ts
    sk.ts
    sr.ts
    sr@ijekavian.ts
    sr@ijekavianlatin.ts
    sr@latin.ts
    sv.ts
    tr.ts
    uk.ts
    zh_CN.ts
    zh_TW.ts
)

qt5_add_translation(QM_FILES ${TRANSLATION_FILES})

install(FILES ${QM_FILES} DESTINATION "${COMPONENTS_TRANSLATION_DIR}")

add_custom_target(components-translation DEPENDS ${QM_FILES})

=== src/daemon/CMakeLists.txt ===
include_directories(
    "${CMAKE_SOURCE_DIR}/src/common"
    "${CMAKE_SOURCE_DIR}/src/auth"
    "${CMAKE_BINARY_DIR}/src/common"
    "${LIBXCB_INCLUDE_DIR}"
)

set(DAEMON_SOURCES
    ${CMAKE_SOURCE_DIR}/src/common/Configuration.cpp
    ${CMAKE_SOURCE_DIR}/src/common/SafeDataStream.cpp
    ${CMAKE_SOURCE_DIR}/src/common/ConfigReader.cpp
    ${CMAKE_SOURCE_DIR}/src/common/ThemeConfig.cpp
    ${CMAKE_SOURCE_DIR}/src/common/ThemeMetadata.cpp
    ${CMAKE_SOURCE_DIR}/src/common/Session.cpp
    ${CMAKE_SOURCE_DIR}/src/common/SocketWriter.cpp
    ${CMAKE_SOURCE_DIR}/src/auth/Auth.cpp
    ${CMAKE_SOURCE_DIR}/src/auth/AuthPrompt.cpp
    ${CMAKE_SOURCE_DIR}/src/auth/AuthRequest.cpp

    DaemonApp.cpp
    Display.cpp
    DisplayManager.cpp
    DisplayServer.cpp
    LogindDBusTypes.cpp
    XorgDisplayServer.cpp
    Greeter.cpp
    PowerManager.cpp
    Seat.cpp
    SeatManager.cpp
    SignalHandler.cpp
    SocketServer.cpp
)

# Different implementations of the VT switching code
# (where the FreeBSD version does nothing).
if(${CMAKE_SYSTEM} MATCHES "FreeBSD")
    list(APPEND DAEMON_SOURCES ${CMAKE_SOURCE_DIR}/src/common/VirtualTerminal_FreeBSD.cpp)
else()
    list(APPEND DAEMON_SOURCES ${CMAKE_SOURCE_DIR}/src/common/VirtualTerminal.cpp)
endif()

qt5_add_dbus_adaptor(DAEMON_SOURCES "${CMAKE_SOURCE_DIR}/data/interfaces/org.freedesktop.DisplayManager.xml"          "DisplayManager.h" SDDM::DisplayManager)
qt5_add_dbus_adaptor(DAEMON_SOURCES "${CMAKE_SOURCE_DIR}/data/interfaces/org.freedesktop.DisplayManager.Seat.xml"     "DisplayManager.h" SDDM::DisplayManagerSeat)
qt5_add_dbus_adaptor(DAEMON_SOURCES "${CMAKE_SOURCE_DIR}/data/interfaces/org.freedesktop.DisplayManager.Session.xml"  "DisplayManager.h" SDDM::DisplayManagerSession)


set_source_files_properties("${CMAKE_SOURCE_DIR}/data/interfaces/org.freedesktop.login1.Manager.xml" PROPERTIES
   INCLUDE "LogindDBusTypes.h"
)
set_source_files_properties("${CMAKE_SOURCE_DIR}/data/interfaces/org.freedesktop.login1.Seat.xml" PROPERTIES
   INCLUDE "LogindDBusTypes.h"
)

set_source_files_properties("${CMAKE_SOURCE_DIR}/data/interfaces/org.freedesktop.login1.Session.xml" PROPERTIES
   INCLUDE "LogindDBusTypes.h"
)

qt5_add_dbus_interface(DAEMON_SOURCES "${CMAKE_SOURCE_DIR}/data/interfaces/org.freedesktop.login1.Manager.xml"  "Login1Manager")
qt5_add_dbus_interface(DAEMON_SOURCES "${CMAKE_SOURCE_DIR}/data/interfaces/org.freedesktop.login1.Seat.xml"  "Login1Seat")
qt5_add_dbus_interface(DAEMON_SOURCES "${CMAKE_SOURCE_DIR}/data/interfaces/org.freedesktop.login1.Session.xml"  "Login1Session")

add_executable(sddm ${DAEMON_SOURCES})
target_link_libraries(sddm
                      Qt5::DBus
                      Qt5::Network
                      Qt5::Qml
                      ${LIBXCB_LIBRARIES})
if(PAM_FOUND)
    target_link_libraries(sddm ${PAM_LIBRARIES})
else()
    target_link_libraries(sddm crypt)
endif()

if(JOURNALD_FOUND)
    target_link_libraries(sddm ${JOURNALD_LIBRARIES})
endif()

install(TARGETS sddm DESTINATION "${CMAKE_INSTALL_BINDIR}")

=== src/greeter/CMakeLists.txt ===
include_directories(
    "${CMAKE_SOURCE_DIR}/src/common"
    "${CMAKE_BINARY_DIR}/src/common"
    "${LIBXCB_INCLUDE_DIR}"
)

set(GREETER_SOURCES
    ${CMAKE_SOURCE_DIR}/src/common/Configuration.cpp
    ${CMAKE_SOURCE_DIR}/src/common/ConfigReader.cpp
    ${CMAKE_SOURCE_DIR}/src/common/Session.cpp
    ${CMAKE_SOURCE_DIR}/src/common/SocketWriter.cpp
    ${CMAKE_SOURCE_DIR}/src/common/ThemeConfig.cpp
    ${CMAKE_SOURCE_DIR}/src/common/ThemeMetadata.cpp
    GreeterApp.cpp
    GreeterProxy.cpp
    KeyboardLayout.cpp
    KeyboardModel.cpp
    ScreenModel.cpp
    SessionModel.cpp
    UserModel.cpp
    XcbKeyboardBackend.cpp
)

configure_file("theme.qrc" "theme.qrc")

qt5_add_resources(RESOURCES ${CMAKE_CURRENT_BINARY_DIR}/theme.qrc)

add_executable(sddm-greeter ${GREETER_SOURCES} ${RESOURCES})
target_link_libraries(sddm-greeter
                      Qt5::Quick
                      ${LIBXCB_LIBRARIES}
                      ${LIBXKB_LIBRARIES})

if(JOURNALD_FOUND)
    target_link_libraries(sddm-greeter ${JOURNALD_LIBRARIES})
endif()

# Translations
add_dependencies(sddm-greeter components-translation)
add_dependencies(sddm-greeter themes-translation)

install(TARGETS sddm-greeter DESTINATION "${CMAKE_INSTALL_BINDIR}")

=== src/helper/CMakeLists.txt ===
include(CheckLibraryExists)

include_directories(
    "${CMAKE_SOURCE_DIR}/src/common"
    "${CMAKE_SOURCE_DIR}/src/auth"
)
include_directories("${CMAKE_BINARY_DIR}/src/common")

set(HELPER_SOURCES
    ${CMAKE_SOURCE_DIR}/src/common/Configuration.cpp
    ${CMAKE_SOURCE_DIR}/src/common/ConfigReader.cpp
    ${CMAKE_SOURCE_DIR}/src/common/SafeDataStream.cpp
    Backend.cpp
    HelperApp.cpp
    UserSession.cpp
)

# Different implementations of the VT switching code
# (where the FreeBSD version does nothing).
if(${CMAKE_SYSTEM} MATCHES "FreeBSD")
    list(APPEND HELPER_SOURCES ${CMAKE_SOURCE_DIR}/src/common/VirtualTerminal_FreeBSD.cpp)
else()
    list(APPEND HELPER_SOURCES ${CMAKE_SOURCE_DIR}/src/common/VirtualTerminal.cpp)
endif()

if(PAM_FOUND)
    set(HELPER_SOURCES
        ${HELPER_SOURCES}
        backend/PamHandle.cpp
        backend/PamBackend.cpp
    )
else()
    set(HELPER_SOURCES
        ${HELPER_SOURCES}
        backend/PasswdBackend.cpp
    )

   if(HAVE_GETSPNAM)
       add_definitions(-DHAVE_GETSPNAM=1)
   endif()
endif()

add_executable(sddm-helper ${HELPER_SOURCES})
target_link_libraries(sddm-helper Qt5::Network Qt5::DBus Qt5::Qml)
if("${CMAKE_SYSTEM_NAME}" STREQUAL "FreeBSD")
    # On FreeBSD (possibly other BSDs as well), we want to use
    # setusercontext() to set up the login configuration from login.conf
    find_library(_have_libutil util)
    if(_have_libutil)
        check_library_exists(${_have_libutil} setusercontext "" _have_setusercontext)
    endif()
    if(_have_libutil AND _have_setusercontext)
        target_link_libraries(sddm-helper ${_have_libutil})
    endif()
endif()

if(PAM_FOUND)
    target_link_libraries(sddm-helper ${PAM_LIBRARIES})
else()
    target_link_libraries(sddm-helper crypt)
endif()

if(JOURNALD_FOUND)
    target_link_libraries(sddm-helper ${JOURNALD_LIBRARIES})
endif()

install(TARGETS sddm-helper RUNTIME DESTINATION "${CMAKE_INSTALL_LIBEXECDIR}")

=== debian/changelog ===
sddm (0.19.0-5) unstable; urgency=medium

  * Drop haveged from recommends, it used to be necessary to gather enough
    entropy to avoid freezes during boot but this hasn’t been the case anymore
    for many kernel releases.

 -- Aurélien COUDERC <coucouf@debian.org>  Mon, 20 Feb 2023 22:51:20 +0100

sddm (0.19.0-4) unstable; urgency=medium

  * Team upload.

  [ Norbert Preining ]
  * Recommend sddm-theme-debian-breeze instead of maui (Closes: #949340).
    The alternatives system gives this theme the highest priority, so install
    it by default.

  [ Pino Toscano ]
  * Remove inactive Uploaders.
  * Backport upstream commit e93bf95c54ad8c2a1604f8d7be05339164b19308 to fix
    build with newer versions of Qt 5.15; patch
    upstream_Fix-compilation-once-QTBUG-88431-gets-fixed.patch.
    (Closes: #1013550)
  * Update lintian overrides.
  * Use /usr/share/dpkg/architecture.mk instead of querying the $DEB_HOST_*
    variables manually.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Update standards version to 4.6.1, no changes needed.
  * Remove the upstream sddm.service in execute_after_dh_auto_install, rather
    than execute_before_dh_install; same effect, mostly a better place
    logically.
  * Use execute_after_dh_fixperms-arch, and execute_after_dh_installpam to avoid
    invoking dh_fixperms, and dh_installpam manually.

 -- Pino Toscano <pino@debian.org>  Sun, 09 Oct 2022 10:30:14 +0200

sddm (0.19.0-3) unstable; urgency=medium

  * Cherry-pick upstream commit to re-add sourcing of /etc/profile and
    $HOME/.profile for users with fish as their default shell.

 -- Aurélien COUDERC <coucouf@debian.org>  Wed, 17 Mar 2021 22:41:58 +0100

sddm (0.19.0-2) unstable; urgency=medium

  [ Norbert Preining ]
  * Disable 07_fix-desktop-session-env-var.diff imported from Ubuntu
    (Closes: #973907)
  * Add upstream's d/p/upstream-2f034906d-use-only-basename-of-session to
    use only the basename of the session file as session name.

 -- Norbert Preining <norbert@preining.info>  Tue, 10 Nov 2020 04:38:45 +0900

sddm (0.19.0-1) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * New upstream release (0.19.0):
    - Fix X not having access control on startup (fixes CVE-2020-28049)
  * Fix lintian warning command-with-path-in-maintainer-script in postrm.
  * Sync patches with Kubuntu.
  * Switch to UTF-8 encoding for Swedish po translation.
  * Review copyright information.
  * Build with hardening=+all build hardening flag.
  * Mark watch file as version=4, no change required.
  * Don’t install LICENSE files from source, their contents is already in
    d/copyright.
  * Install upstream README files to /usr/share/doc.
  * Disable lintian warning for Maya theme’s font license, the source gives a
    plausible source and license that are redistribuable.
  * Bump Standards-Version to 4.5.0:
    - Add Rules-Requires-Root: no
  * Switch from the debhelper build dependency to debhelper-compat
    - remove debian/compat
    - bump compatibility level to 13

  [ Norbert Preining ]
  * Bump build-depends according to CMakeLists.
  * Add Aurélien and myself to uploaders.
  * Change maintainer to Debian Qt/KDE ...
  * Don't do recursive change of ownership of /var/lib/sddm in d/sddm.postinst

 -- Norbert Preining <norbert@preining.info>  Sat, 07 Nov 2020 09:28:39 +0900

=== debian/control ===
Source: sddm
Section: kde
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
Build-Depends: cmake (>= 2.8.8),
               debhelper-compat (= 13),
               extra-cmake-modules (>= 1.4.0~),
               libpam0g-dev,
               libsystemd-dev [linux-any],
               libupower-glib-dev,
               libxcb-xkb-dev,
               libxcb1-dev,
               libxkbcommon-dev,
               pkg-config,
               python3-docutils,
               qtbase5-dev (>= 5.8.0~),
               qtdeclarative5-dev (>= 5.8.0~),
               qttools5-dev,
               qttools5-dev-tools (>= 5.8.0~),
               systemd [linux-any],
Standards-Version: 4.6.1
Homepage: https://github.com/sddm/sddm
Vcs-Browser: https://salsa.debian.org/qt-kde-team/3rdparty/sddm
Vcs-Git: https://salsa.debian.org/qt-kde-team/3rdparty/sddm.git
Rules-Requires-Root: no

Package: sddm
Architecture: any
Depends: adduser,
         qml-module-qtquick2,
         xauth,
         x11-common,
         xserver-xorg | xserver,
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: libpam-systemd, sddm-theme-debian-breeze | sddm-theme
Suggests: libpam-kwallet5, qtvirtualkeyboard-plugin
Provides: x-display-manager
Description: modern display manager for X11
 SDDM is a modern display manager for X11 aiming to be fast, simple
 and beautiful. It uses modern technologies like QtQuick to create
 smooth, animated user interfaces.

Package: sddm-theme-debian-elarun
Architecture: all
Depends: desktop-base, ${misc:Depends}
Recommends: sddm
Provides: sddm-theme
Breaks: sddm (<< ${source:Version})
Description: 'Debian Elarun' Theme for SDDM X11 display manager
 Elarun theme for SDDM, using the active desktop-base theme for the
 background.

Package: sddm-theme-debian-maui
Architecture: all
Depends: desktop-base, ${misc:Depends}
Recommends: sddm
Provides: sddm-theme
Breaks: sddm (<< ${source:Version})
Description: 'Debian Maui' theme for SDDM X11 display manager
 Maui theme for SDDM, using the active desktop-base theme for the
 background

Package: sddm-theme-elarun
Architecture: all
Depends: ${misc:Depends}
Recommends: sddm
Provides: sddm-theme
Breaks: sddm (<< ${source:Version})
Description: 'Elarun' Theme for SDDM X11 display manager
 Elarun theme for SDDM

Package: sddm-theme-maldives
Architecture: all
Depends: ${misc:Depends}
Breaks: sddm (<< ${source:Version})
Recommends: sddm
Provides: sddm-theme
Description: 'Maldives' theme for SDDM X11 display manager
 Maldives theme for SDDM

Package: sddm-theme-maui
Architecture: all
Depends: ${misc:Depends}
Recommends: sddm
Provides: sddm-theme
Breaks: sddm (<< ${source:Version})
Description: 'Maui' theme for SDDM X11 display manager
 Maui theme for SDDM

Package: sddm-theme-maya
Architecture: all
Depends: ${misc:Depends}
Recommends: sddm
Provides: sddm-theme
Breaks: sddm (<< ${source:Version})
Description: 'Maya' theme for SDDM X11 display manager
 Maya theme for SDDM

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/architecture.mk

SDDM_CMAKE_ARGS = -DCMAKE_INSTALL_LIBEXECDIR=/usr/lib/${DEB_HOST_MULTIARCH}/sddm \
	    -DSESSION_COMMAND="/etc/sddm/Xsession" \
	    -DWAYLAND_SESSION_COMMAND="/etc/sddm/wayland-session" \
	    -DBUILD_MAN_PAGES=ON \
	    -DDBUS_CONFIG_FILENAME="sddm_org.freedesktop.DisplayManager.conf"

ifneq ($(DEB_HOST_ARCH_OS),linux)
  SDDM_CMAKE_ARGS += -DNO_SYSTEMD=ON -DENABLE_JOURNALD=OFF
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- ${SDDM_CMAKE_ARGS}

override_dh_installsystemd:
	dh_installsystemd -psddm --no-start -r sddm.service

override_dh_installinit:
	dh_installinit --noscripts

execute_after_dh_auto_install:
	# not installed, as the Debian version is used instead
	rm -f $(CURDIR)/debian/tmp/lib/systemd/system/sddm.service

execute_after_dh_fixperms-arch:
	# ensure script is marked as executable
	chmod +x $(CURDIR)/debian/sddm/etc/sddm/Xsession

execute_after_dh_installpam:
	dh_installpam --name=sddm-autologin
	dh_installpam --name=sddm-greeter

## sddm 0.20.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.8.8)
+cmake_minimum_required(VERSION 3.4)
 
 project(SDDM)
 
@@ -6,16 +6,12 @@
 set(CMAKE_AUTOMOC ON)
 SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
 
-# Silence CMake 3.0 warnings
-if(POLICY CMP0043)
-    cmake_policy(SET CMP0043 OLD)
-endif()
-
 # Set version
 set(SDDM_VERSION_MAJOR 0)
-set(SDDM_VERSION_MINOR 19)
+set(SDDM_VERSION_MINOR 20)
 set(SDDM_VERSION_PATCH 0)
 set(SDDM_VERSION_STRING "${SDDM_VERSION_MAJOR}.${SDDM_VERSION_MINOR}.${SDDM_VERSION_PATCH}")
+add_compile_definitions("SDDM_VERSION=\"${SDDM_VERSION_STRING}\"")
 
 # Set up packaging
 set(CPACK_PACKAGE_NAME "sddm")
@@ -30,16 +26,19 @@
 # Options
 option(BUILD_MAN_PAGES "Build man pages" OFF)
 option(ENABLE_JOURNALD "Enable logging to journald" ON)
-option(ENABLE_PAM "Enable PAM support" ON)
 option(NO_SYSTEMD "Disable systemd support" OFF)
 option(USE_ELOGIND "Use elogind instead of logind" OFF)
+option(BUILD_WITH_QT6 "Build with Qt 6" OFF)
+
+set(CMAKE_CXX_STANDARD 17)
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
 # ECM
 find_package(ECM 1.4.0 REQUIRED NO_MODULE)
 set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake;${CMAKE_MODULE_PATH};${ECM_MODULE_PATH}")
 
 # Definitions
-add_definitions(-Wall -std=c++11 -DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_FROM_BYTEARRAY -DQT_NO_FOREACH)
+add_definitions(-Wall -Wextra -DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_FROM_BYTEARRAY -DQT_NO_FOREACH)
 
 # Default build type
 if(NOT CMAKE_BUILD_TYPE)
@@ -75,18 +74,10 @@
 find_package(PkgConfig)
 
 # PAM
-if(ENABLE_PAM)
-    find_package(PAM REQUIRED)
-
-    if(PAM_FOUND)
-        add_definitions(-DUSE_PAM)
-    endif()
-endif()
-add_feature_info("PAM" PAM_FOUND "PAM support")
-
-# getspnam and shadow(5) support
-include(CheckFunctionExists)
-check_function_exists(getspnam HAVE_GETSPNAM)
+find_package(PAM REQUIRED)
+
+# XAU
+pkg_check_modules(LIBXAU REQUIRED "xau")
 
 # XCB
 find_package(XCB REQUIRED)
@@ -94,13 +85,21 @@
 # XKB
 find_package(XKB REQUIRED)
 
-# Qt 5
-find_package(Qt5 5.8.0 CONFIG REQUIRED Core DBus Gui Qml Quick LinguistTools Test)
+# Qt
+if(BUILD_WITH_QT6)
+    set(QT_MAJOR_VERSION 6)
+    message(STATUS "Building Qt 6 version")
+else()
+    set(QT_MAJOR_VERSION 5)
+    message(STATUS "Building Qt 5 version")
+endif()
+
+find_package(Qt${QT_MAJOR_VERSION} 5.15.0 CONFIG REQUIRED Core DBus Gui Qml Quick LinguistTools Test QuickTest)
 
 # find qt5 imports dir
-get_target_property(QMAKE_EXECUTABLE Qt5::qmake LOCATION)
+get_target_property(QMAKE_EXECUTABLE Qt${QT_MAJOR_VERSION}::qmake LOCATION)
 if(NOT QT_IMPORTS_DIR)
-    exec_program(${QMAKE_EXECUTABLE} ARGS "-query QT_INSTALL_QML" RETURN_VALUE return_code OUTPUT_VARIABLE QT_IMPORTS_DIR)
+    execute_process(COMMAND ${QMAKE_EXECUTABLE} -query QT_INSTALL_QML OUTPUT_VARIABLE QT_IMPORTS_DIR OUTPUT_STRIP_TRAILING_WHITESPACE)
 endif()
 
 # Uninstall target
@@ -137,11 +136,17 @@
     endif()
 
     if (NOT DEFINED SYSTEMD_SYSTEM_UNIT_DIR)
-        execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} --variable=systemdsystemunitdir systemd OUTPUT_VARIABLE SYSTEMD_SYSTEM_UNIT_DIR)
-        string(REGEX REPLACE "[ \t\n]+" "" SYSTEMD_SYSTEM_UNIT_DIR ${SYSTEMD_SYSTEM_UNIT_DIR})
-    endif()
-
-    set(MINIMUM_VT 1)
+        pkg_get_variable(SYSTEMD_SYSTEM_UNIT_DIR systemd systemdsystemunitdir)
+    endif()
+
+    if (NOT DEFINED SYSTEMD_SYSUSERS_DIR)
+        pkg_get_variable(SYSTEMD_SYSUSERS_DIR systemd sysusersdir)
+    endif()
+
+    if (NOT DEFINED SYSTEMD_TMPFILES_DIR)
+        pkg_get_variable(SYSTEMD_TMPFILES_DIR systemd tmpfilesdir)
+    endif()
+
     set(HALT_COMMAND "/usr/bin/systemctl poweroff")
     set(REBOOT_COMMAND "/usr/bin/systemctl reboot")
 else()
@@ -159,7 +164,6 @@
     add_definitions(-DHAVE_ELOGIND)
     set(CMAKE_AUTOMOC_MOC_OPTIONS -DHAVE_ELOGIND)
 
-    set(MINIMUM_VT 7)
     set(HALT_COMMAND "/usr/bin/loginctl poweroff")
     set(REBOOT_COMMAND "/usr/bin/loginctl reboot")
 endif()
@@ -171,13 +175,17 @@
     # commands for shutdown and reboot. On FreeBSD, there are
     # normally more getty's running than on Linux.
     if("${CMAKE_SYSTEM_NAME}" STREQUAL "FreeBSD")
-        set(MINIMUM_VT 9)
         set(HALT_COMMAND "/sbin/shutdown -p now")
     else()
-        set(MINIMUM_VT 7)
         set(HALT_COMMAND "/sbin/shutdown -h -P now")
     endif()
     set(REBOOT_COMMAND "/sbin/shutdown -r now")
+endif()
+
+if (SYSTEMD_FOUND)
+    set(RUNTIME_DIR_DEFAULT "/run/sddm")
+else()
+    set(RUNTIME_DIR_DEFAULT "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/run/sddm")
 endif()
 
 
@@ -185,7 +193,7 @@
 set(DATA_INSTALL_DIR            "${CMAKE_INSTALL_FULL_DATADIR}/sddm"                CACHE PATH      "System application data install directory")
 set(DBUS_CONFIG_DIR             "${CMAKE_INSTALL_SYSCONFDIR}/dbus-1/system.d"       CACHE PATH      "DBus config files directory")
 set(STATE_DIR                   "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/lib/sddm"      CACHE PATH      "State directory")
-set(RUNTIME_DIR                 "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/run/sddm"      CACHE PATH      "Runtime data storage directory")
+set(RUNTIME_DIR                 "${RUNTIME_DIR_DEFAULT}"                            CACHE PATH      "Runtime data storage directory")
 set(QML_INSTALL_DIR             "${QT_IMPORTS_DIR}"                                 CACHE PATH      "QML component installation directory")
 
 set(SESSION_COMMAND             "${DATA_INSTALL_DIR}/scripts/Xsession"              CACHE PATH      "Script to execute when starting the X11 desktop session")
@@ -193,10 +201,12 @@
 
 set(CONFIG_FILE                 "${CMAKE_INSTALL_FULL_SYSCONFDIR}/sddm.conf"        CACHE PATH      "Path of the sddm config file")
 set(CONFIG_DIR                  "${CMAKE_INSTALL_FULL_SYSCONFDIR}/sddm.conf.d"      CACHE PATH      "Path of the sddm config directory")
+set(ACCOUNTSSERVICE_DATA_DIR    "/var/lib/AccountsService"                          CACHE PATH      "Path of the accountsservice data directory")
 set(SYSTEM_CONFIG_DIR           "${CMAKE_INSTALL_PREFIX}/lib/sddm/sddm.conf.d"      CACHE PATH      "Path of the system sddm config directory")
 set(LOG_FILE                    "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/log/sddm.log"  CACHE PATH      "Path of the sddm log file")
 set(DBUS_CONFIG_FILENAME        "org.freedesktop.DisplayManager.conf"               CACHE STRING    "Name of the sddm config file")
 set(COMPONENTS_TRANSLATION_DIR  "${DATA_INSTALL_DIR}/translations"                  CACHE PATH      "Components translations directory")
+set(SDDM_INITIAL_VT             "1"                                                 CACHE STRING    "Initial tty to use")
 
 
 # Autodetect UID_MIN and UID_MAX from /etc/login.defs

=== components/CMakeLists.txt ===
configure_file("2.0/LayoutBox.qml" "2.0/LayoutBox.qml")

install(DIRECTORY "2.0/" DESTINATION "${QML_INSTALL_DIR}/SddmComponents" PATTERN "LayoutBox.qml" EXCLUDE)
install(DIRECTORY "common/" DESTINATION "${QML_INSTALL_DIR}/SddmComponents")
install(DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/2.0/" DESTINATION "${QML_INSTALL_DIR}/SddmComponents")

=== services/CMakeLists.txt ===
if(SYSTEMD_FOUND)
    configure_file(sddm.service.in sddm.service)
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/sddm.service" DESTINATION "${SYSTEMD_SYSTEM_UNIT_DIR}")

    configure_file(sddm-sysuser.conf.in sddm-sysuser.conf)
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/sddm-sysuser.conf" DESTINATION "${SYSTEMD_SYSUSERS_DIR}" RENAME sddm.conf)
endif()

# systemd-tmpfiles can be used standalone without other systemd parts
if(DEFINED SYSTEMD_TMPFILES_DIR)
    configure_file(sddm-tmpfiles.conf.in sddm-tmpfiles.conf)
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/sddm-tmpfiles.conf" DESTINATION "${SYSTEMD_TMPFILES_DIR}" RENAME sddm.conf)
endif()

if(USE_ELOGIND)
    set(LOGIND_PAM_MODULE "pam_elogind.so")
else()
    set(LOGIND_PAM_MODULE "pam_systemd.so")
endif()
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/sddm-greeter.pam.in" "${CMAKE_CURRENT_BINARY_DIR}/sddm-greeter.pam")

if(EXISTS "/etc/debian_version")
    install(FILES debian.sddm-autologin.pam DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/pam.d RENAME sddm-autologin)
    install(FILES debian.sddm-greeter.pam DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/pam.d RENAME sddm-greeter)
    install(FILES debian.sddm.pam DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/pam.d RENAME sddm)
else()
    if(HAVE_PAM_FAILLOCK)
        install(FILES sddm-autologin.pam DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/pam.d RENAME sddm-autologin)
    else()
        install(FILES sddm-autologin-tally2.pam DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/pam.d RENAME sddm-autologin)
    endif()

    install(FILES sddm.pam DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/pam.d RENAME sddm)
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/sddm-greeter.pam" DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/pam.d RENAME sddm-greeter)
endif()

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -6,4 +6,10 @@
 add_executable(ConfigurationTest ${ConfigurationTest_SRCS})
 add_test(NAME Configuration COMMAND ConfigurationTest)
 
-target_link_libraries(ConfigurationTest Qt5::Core Qt5::Test)
+target_link_libraries(ConfigurationTest Qt${QT_MAJOR_VERSION}::Core Qt${QT_MAJOR_VERSION}::Test)
+
+set(QMLThemeConfigTest_SRCS QMLThemeConfigTest.cpp ../src/common/ThemeConfig.cpp ../src/common/ThemeConfig.h)
+add_executable(QMLThemeConfigTest ${QMLThemeConfigTest_SRCS})
+target_include_directories(QMLThemeConfigTest PRIVATE ../src/common/)
+add_test(NAME QMLThemeConfig COMMAND QMLThemeConfigTest -platform offscreen -input ${CMAKE_CURRENT_SOURCE_DIR}/QMLThemeConfigTest.qml WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
+target_link_libraries(QMLThemeConfigTest PRIVATE Qt${QT_MAJOR_VERSION}::Quick Qt${QT_MAJOR_VERSION}::QuickTest)

=== data/translations/CMakeLists.txt ===
--- 
+++ 
@@ -10,6 +10,7 @@
     eu.ts
     fi.ts
     fr.ts
+    gl.ts
     hi_IN.ts
     he.ts
     hu.ts
@@ -17,6 +18,7 @@
     is.ts
     it.ts
     ja.ts
+    ka.ts
     kk.ts
     ko.ts
     lt.ts
@@ -42,7 +44,7 @@
     zh_TW.ts
 )
 
-qt5_add_translation(QM_FILES ${TRANSLATION_FILES})
+qt_add_translation(QM_FILES ${TRANSLATION_FILES})
 
 install(FILES ${QM_FILES} DESTINATION "${COMPONENTS_TRANSLATION_DIR}")

=== src/greeter/CMakeLists.txt ===
--- 
+++ 
@@ -8,6 +8,7 @@
     ${CMAKE_SOURCE_DIR}/src/common/Configuration.cpp
     ${CMAKE_SOURCE_DIR}/src/common/ConfigReader.cpp
     ${CMAKE_SOURCE_DIR}/src/common/Session.cpp
+    ${CMAKE_SOURCE_DIR}/src/common/SignalHandler.cpp
     ${CMAKE_SOURCE_DIR}/src/common/SocketWriter.cpp
     ${CMAKE_SOURCE_DIR}/src/common/ThemeConfig.cpp
     ${CMAKE_SOURCE_DIR}/src/common/ThemeMetadata.cpp
@@ -18,16 +19,18 @@
     ScreenModel.cpp
     SessionModel.cpp
     UserModel.cpp
+    waylandkeyboardbackend.cpp
+    waylandkeyboardbackend.h
     XcbKeyboardBackend.cpp
 )
 
 configure_file("theme.qrc" "theme.qrc")
 
-qt5_add_resources(RESOURCES ${CMAKE_CURRENT_BINARY_DIR}/theme.qrc)
+qt_add_resources(RESOURCES ${CMAKE_CURRENT_BINARY_DIR}/theme.qrc)
 
 add_executable(sddm-greeter ${GREETER_SOURCES} ${RESOURCES})
 target_link_libraries(sddm-greeter
-                      Qt5::Quick
+                      Qt${QT_MAJOR_VERSION}::Quick
                       ${LIBXCB_LIBRARIES}
                       ${LIBXKB_LIBRARIES})

=== src/helper/CMakeLists.txt ===
include(CheckLibraryExists)

include_directories(
    "${CMAKE_SOURCE_DIR}/src/common"
    "${CMAKE_SOURCE_DIR}/src/auth"
    ${LIBXAU_INCLUDE_DIRS}
)
include_directories("${CMAKE_BINARY_DIR}/src/common")

set(HELPER_SOURCES
    ${CMAKE_SOURCE_DIR}/src/common/Configuration.cpp
    ${CMAKE_SOURCE_DIR}/src/common/ConfigReader.cpp
    ${CMAKE_SOURCE_DIR}/src/common/SafeDataStream.cpp
    ${CMAKE_SOURCE_DIR}/src/common/XAuth.cpp
    ${CMAKE_SOURCE_DIR}/src/common/SignalHandler.cpp
    ${CMAKE_SOURCE_DIR}/src/auth/Auth.cpp
    ${CMAKE_SOURCE_DIR}/src/auth/AuthRequest.cpp
    ${CMAKE_SOURCE_DIR}/src/auth/AuthPrompt.cpp
    Backend.cpp
    HelperApp.cpp
    UserSession.cpp
)

list(APPEND HELPER_SOURCES ${CMAKE_SOURCE_DIR}/src/common/VirtualTerminal.cpp)

set(HELPER_SOURCES
    ${HELPER_SOURCES}
    backend/PamHandle.cpp
    backend/PamBackend.cpp
)

add_executable(sddm-helper ${HELPER_SOURCES})
target_link_libraries(sddm-helper
                      Qt${QT_MAJOR_VERSION}::Network
                      Qt${QT_MAJOR_VERSION}::DBus
                      Qt${QT_MAJOR_VERSION}::Qml
                      ${LIBXAU_LINK_LIBRARIES})
if("${CMAKE_SYSTEM_NAME}" STREQUAL "FreeBSD")
    # On FreeBSD (possibly other BSDs as well), we want to use
    # setusercontext() to set up the login configuration from login.conf
    find_library(_have_libutil util)
    if(_have_libutil)
        check_library_exists(${_have_libutil} setusercontext "" _have_setusercontext)
    endif()
    if(_have_libutil AND _have_setusercontext)
        target_link_libraries(sddm-helper ${_have_libutil})
    endif()
endif()

if(PAM_FOUND)
    target_link_libraries(sddm-helper ${PAM_LIBRARIES})
else()
    target_link_libraries(sddm-helper crypt)
endif()

install(TARGETS sddm-helper RUNTIME DESTINATION "${CMAKE_INSTALL_LIBEXECDIR}")

add_executable(sddm-helper-start-wayland HelperStartWayland.cpp waylandsocketwatcher.cpp waylandhelper.cpp ${CMAKE_SOURCE_DIR}/src/common/SignalHandler.cpp)
target_link_libraries(sddm-helper-start-wayland Qt${QT_MAJOR_VERSION}::Core)
install(TARGETS sddm-helper-start-wayland RUNTIME DESTINATION "${CMAKE_INSTALL_LIBEXECDIR}")

add_executable(sddm-helper-start-x11user HelperStartX11User.cpp xorguserhelper.cpp
                                                ${CMAKE_SOURCE_DIR}/src/common/ConfigReader.cpp
                                                ${CMAKE_SOURCE_DIR}/src/common/Configuration.cpp
                                                ${CMAKE_SOURCE_DIR}/src/common/XAuth.cpp
                                                ${CMAKE_SOURCE_DIR}/src/common/SignalHandler.cpp
                                                )
target_link_libraries(sddm-helper-start-x11user Qt${QT_MAJOR_VERSION}::Core
                                                ${LIBXAU_LINK_LIBRARIES})
install(TARGETS sddm-helper-start-x11user RUNTIME DESTINATION "${CMAKE_INSTALL_LIBEXECDIR}")

if(JOURNALD_FOUND)
    target_link_libraries(sddm-helper ${JOURNALD_LIBRARIES})
    target_link_libraries(sddm-helper-start-x11user ${JOURNALD_LIBRARIES})
    target_link_libraries(sddm-helper-start-wayland ${JOURNALD_LIBRARIES})
endif()

=== debian/changelog ===
sddm (0.20.0-2ubuntu4) noble; urgency=high

  * No change rebuild against libqt5core5t64, libqt5dbus5t64,
    libqt5gui5t64, libqt5network5t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 08 Apr 2024 16:49:55 +0200

sddm (0.20.0-2ubuntu3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 17:12:06 +0000

sddm (0.20.0-2ubuntu2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 07:04:10 +0000

sddm (0.20.0-2ubuntu1) noble; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Keep the default-display-manager file logic in sddm.postinst.
    - Update Vcs-* to point to Launchpad instead of Salsa.
    - Make sure sddm.service starts at the correct time.
    - Instead of hardcoding the Breeze theme in, allow ubuntu-theme to be
      used in the same fashion Debian's is.
    - Revert upstream change prefering wayland sessions.
      + debian/patches: revert_prefer-wayland-sessions-over-X11.patch
      + Refresh the above patch.
    - Patch to avoid screen overlap or inset.
    - Patch Xsetup script to use bash. Allows previous patch to actually
      run as it requires arrays.

 -- Rik Mills <rikmills@kde.org>  Mon, 11 Dec 2023 11:52:38 +0000

sddm (0.20.0-2) unstable; urgency=medium

  * Team upload.

  [ Pino Toscano ]
  * Add the xkb-data dependency, needed for the X11 xkb rules.
  * Remove an obsolete maintscript entry.

  [ Patrick Franz ]
  * Fix FTBFS: Also ignore /usr-moved upstream systemd unit, thx to
    Helmut Grohne (Closes: #1057338).

 -- Patrick Franz <deltaone@debian.org>  Mon, 04 Dec 2023 22:08:35 +0100

sddm (0.20.0-1ubuntu1) mantic; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Keep the default-display-manager file logic in sddm.postinst.
    - Update Vcs-* to point to Launchpad instead of Salsa.
    - Make sure sddm.service starts at the correct time.
    - Instead of hardcoding the Breeze theme in, allow ubuntu-theme to be
      used in the same fashion Debian's is.
    - Revert upstream change prefering wayland sessions.
      + debian/patches: revert_prefer-wayland-sessions-over-X11.patch
      + Refresh the above patch.
    - Patch to avoid screen overlap or inset.
    - Patch Xsetup script to use bash. Allows previous patch to actually
      run as it requires arrays,

 -- Rik Mills <rikmills@kde.org>  Thu, 29 Jun 2023 14:30:54 +0100

sddm (0.20.0-1) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * New upstream release (0.20.0).
  * Update build-deps and deps with the info from cmake.
  * Bump Standards-Version to 4.6.2, no change required.
  * Refresh patches.
  * Drop patch 03_vt7-minimum-vt.diff and switch back to upstream default of
    spawning greeter on VT1.
  * Drop patches applied upstream.
  * Refresh the list of installed files.

 -- Aurélien COUDERC <coucouf@debian.org>  Sat, 24 Jun 2023 08:38:52 +0200

sddm (0.19.0-5ubuntu1) mantic; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Add kubuntu_nvidia-prime.diff to make sure NVIDIA Prime works.
    - Keep the default-display-manager file logic in sddm.postinst.
    - Update Vcs-* to point to Launchpad instead of Salsa.
    - Add debian/conffiles.
    - Make sure sddm.service starts at the correct time.
    - Start on tty1 by default.
    - Instead of hardcoding the Breeze theme in, allow ubuntu-theme to be
      used in the same fashion Debian's is.
    - Revert upstream change prefering wayland sessions.
      + debian/patches: revert_prefer-wayland-sessions-over-X11.patch
    - Patch to avoid screen overlap or inset.
    - Patch Xsetup script to use bash. Allows previous patch to actually
      run as it requires arrays

 -- Rik Mills <rikmills@kde.org>  Mon, 26 Jun 2023 10:09:31 +0100

sddm (0.19.0-3ubuntu3) lunar; urgency=medium

  * Patch Xsetup script to use bash (LP: #2009074)
    - Allows previous patch to actually run as it
      requires arrays

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Thu, 02 Mar 2023 11:26:21 -0800

sddm (0.19.0-3ubuntu2) lunar; urgency=medium

  * Patch to avoid screen overlap or inset (LP: #1998254)

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Tue, 29 Nov 2022 13:34:07 -0800

sddm (0.19.0-3ubuntu1) kinetic; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Add kubuntu_nvidia-prime.diff to make sure NVIDIA Prime works.
    - Keep the default-display-manager file logic in sddm.postinst.
    - Update Vcs-* to point to Launchpad instead of Salsa.
    - Add debian/conffiles.
    - Make sure sddm.service starts at the correct time.
    - Start on tty1 by default.
    - Instead of hardcoding the Breeze theme in, allow ubuntu-theme to be
      used in the same fashion Debian's is.
    - Revert upstream change prefering wayland sessions.
      + debian/patches: revert_prefer-wayland-sessions-over-X11.patch
    - Add sddm-fix-build.patch

 -- Rik Mills <rikmills@kde.org>  Tue, 12 Jul 2022 12:19:39 +0100

sddm (0.19.0-2ubuntu2) hirsute; urgency=medium

  * Revert upstream change prefering wayland sessions.
    - debian/patches: revert_prefer-wayland-sessions-over-X11.patch

 -- Rik Mills <rikmills@kde.org>  Thu, 18 Feb 2021 17:33:00 +0000

sddm (0.19.0-2ubuntu1) hirsute; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Add kubuntu_nvidia-prime.diff to make sure NVIDIA Prime works.
    - Keep the default-display-manager file logic in sddm.postinst.
    - Update Vcs-* to point to Launchpad instead of Salsa.
    - Add debian/conffiles.
    - Make sure sddm.service starts at the correct time.
    - Start on tty1 by default.
    - Instead of hardcoding the Breeze theme in, allow ubuntu-theme to be
      used in the same fashion Debian's is.

 -- Rik Mills <rikmills@kde.org>  Sun, 15 Nov 2020 11:53:51 +0000

sddm (0.18.1-1ubuntu3) groovy; urgency=medium



=== debian/rules ===
--- 
+++ 
@@ -30,7 +30,7 @@
 
 execute_after_dh_auto_install:
 	# not installed, as the Debian version is used instead
-	rm -f $(CURDIR)/debian/tmp/lib/systemd/system/sddm.service
+	rm -f $(CURDIR)/debian/tmp/lib/systemd/system/sddm.service $(CURDIR)/debian/tmp/usr/lib/systemd/system/sddm.service
 
 execute_after_dh_fixperms-arch:
 	# ensure script is marked as executable
